%Taktzeit
% T= Taktzeit(qva)
% suche status_output_er in rob_dyn.cpp
%
function t_exec=taktzeit(qva)
%
load VELPROF.dat
t = VELPROF(:,1);
t_exec = VELPROF(:,2:2);
dt = diff(t_exec);
x = VELPROF(:,3:5);
xva_pos = VELPROF(:,6:8);   % iex->X_pos, iex->V_pos, iex->A_pos
xva_ori = VELPROF(:,9:11);   % iex->X_ori, iex->V_ori, iex->A_ori
q = VELPROF(:,12:17);
v = VELPROF(:,18:23);
a = VELPROF(:,24:29);
dq = diff(q);                    % Bilde Differenzen (Anzahl der Punkte wird um 1 reduziert)
dx = diff(x);                    % Bilde Differenzen (Anzahl der Punkte wird um 1 reduziert)
[num,col] = size(dq);      % Spalten und Zeilen von y  

dt1=1;

for i =1:num
     if dt(i)>0 
         dt1 = dt(i);
     end
     dq(i,1:6) = dq(i,1:6)./dt1;
     dx(i,1:3) = dx(i,1:3)./dt1;
end

ax = diff(dx);                    % Bilde Differenzen (Anzahl der Punkte wird um 1 reduziert)
for i =1:num-1
     if dt(i)>0 
         dt1 = dt(i);
     end
     ax(i,1:3) = ax(i,1:3)./dt1;
end

% plot(q(:,1:6));                   % Ausgabe Position
% title('Achs Winkel  bl gr ro cy vio ok');
% pause;
% 
% plot(v(:,1:6));                   % Ausgabe Geschwindigkeit
% title('Achs Geschwindigkeiten  bl gr ro cy vio ok');
% pause;
% 
% plot(x(:,1:3));                   % Ausgabe Position
% title('XYZ Position  bl gr ro');
% pause;

% plot(t_exec(1:num),dx(:,2:2));                   % Ausgabe Geschwindigkeit
% title('XYZ Geschwindigkeit');
% pause;

% plot(t_exec(1:num-1),ax(:,2:2));                   % Ausgabe Beschleunigung
% title('XYZ Beschleunigung');
% pause;

if qva
    n=3;
    plot(t_exec,q(:,1:n));           % Ausgabe q
    title('Joints');
    grid on;
    pause;

    plot(t_exec,v(:,1:n));           % Ausgabe v
    title('Joint Speeds');
    grid on;
    pause;

    plot(t_exec,a(:,1:n));           % Ausgabe a
    title('Joint Accelerations');
    grid on;
    pause;

else 
    plot(t_exec,xva_pos(:,1:1));     % Ausgabe Position
    title('X pos');
    pause;

    plot(t_exec,xva_pos(:,2:2));     % Ausgabe Geschwindigkeit
    title('V pos');
    pause;

    plot(t_exec,xva_pos(:,3:3));     % Ausgabe Beschleunigung
    title('A pos');
    pause;

    plot(t_exec,xva_ori(:,1:1));     % Ausgabe Position ORI
    title('X ori');
    pause;

    plot(t_exec,xva_ori(:,2:2));     % Ausgabe Geschwindigkeit ORI
    title('V ori');
    pause;

    plot(t_exec,xva_ori(:,3:3));     % Ausgabe Beschleunigung ORI
    title('A ori');
    pause;
end